
function initFileXML(deleteFile, filename){
	var file = Components.classes["@mozilla.org/file/directory_service;1"]
			.getService(Components.interfaces.nsIProperties)
			.get("ProfD", Components.interfaces.nsIFile);

	file.append("cl_index");
	file.append("xml");
	file.append(filename);

	if(file.exists() && deleteFile) file.remove(false);

	if(!file.exists()) {
		file.createUnique(Components.interfaces.nsIFile.NORMAL_FILE_TYPE, 0666);
	}

	return file;
}

function writeFile(file, data){
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
	                         .createInstance(Components.interfaces.nsIFileOutputStream);

	// use 0x02 | 0x10 to open file for appending.
	foStream.init(file, 0x02 | 0x08 | 0x10, 0666, 0); 
	foStream.write(data, data.length);
	foStream.close();
}

function writeXMLFile(file, data){
	if(file.exists()) file.remove(false);
	
	var foStream = Components.classes["@mozilla.org/network/file-output-stream;1"]
	                         .createInstance(Components.interfaces.nsIFileOutputStream);

	// use 0x02 | 0x10 to open file for appending.
	foStream.init(file, 0x02 | 0x08 | 0x10, 0666, 0); 
	foStream.write(data, data.length);
	foStream.close();
}

function readFile(file){
	var data = "";
	var fstream = Components.classes["@mozilla.org/network/file-input-stream;1"]
	                        .createInstance(Components.interfaces.nsIFileInputStream);
	var sstream = Components.classes["@mozilla.org/scriptableinputstream;1"]
	                        .createInstance(Components.interfaces.nsIScriptableInputStream);
	fstream.init(file, -1, 0, 0);
	sstream.init(fstream); 

	var str = sstream.read(4096);
	while (str.length > 0) {
	  data += str;
	  str = sstream.read(4096);
	}

	sstream.close();
	fstream.close();
	return data;
}